package ex09.reactive

import java.awt.{Dimension, Graphics2D}

import rescala._
import Animation._
import Time._

import scala.language.postfixOps
import scala.swing.{MainFrame, Panel}


object ReactiveAnimation extends ReactiveSwingApp {
  val Width = 700
  val Height = 600
  val Size = 20

  def top = new MainFrame {
    title = "Reactive Animations"
    resizable = false
    val panel = new Panel {
      preferredSize = new Dimension(Width, Height)
          
      // Your animation signals go here:
      val lineX = (animate(100 ->> 300) in (2 secs) repeat).start

      // setup and redraw code
      val stateChanged = Clock.ticks
      stateChanged += { _ => repaint() }
      
      val time = Signal { Clock.time().inSeconds + "s runnung..." }
      
      override def paintComponent(g: Graphics2D) {
        super.paintComponent(g)
        g.setColor(java.awt.Color.DARK_GRAY)
        g.drawString(time(), 10, 20)
        
        // Drawing goes here
        g.fillOval(lineX().toInt, 100, Size, Size)
        
      }
    }
    contents = panel
  }
}